##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
#
# Modified by Oliver Keller <oli@deswahnsinnsfettebeute.de
# - the image name can now contain any character (umlauts etc. work now) 
# see modified HTMLWithImages.py for detailed comment
# you may want to change "bild" to some other keyword in line 39 and 40
# last changed: 18.03.2003

import re
from DocumentClass import *

class StructuredTextImage(StructuredTextMarkup):
    "A simple embedded image"

class DocumentWithImages(DocumentClass):   
    """

    """
    # add characters here:

    text_types = [
       'doc_img',
       ] + DocumentClass.text_types


    def doc_img(
        self, s,
        expr1=re.compile('\"(.*)\":img:([_a-zA-Z0-9\-.:/;,\n\~]+)').search,
        expr2=re.compile('\"(.*)\":obr:([_a-zA-Z0-9\-.:/;,\n\~]+)').search,
        expr3=re.compile('\"(.*)\":obr-([a-z]+):([_a-zA-Z0-9\-.:/;,\n\~]+)').search,
        expr4=re.compile('\"(.*)\":img-([a-z]+):([_a-zA-Z0-9\-.:/;,\n\~]+)').search
        ):

        r = expr4(s)
        if r:
                startt, endt = r.span(1)
                starth, endh = r.span(3)
                starta, enda = r.span(2)
                start, end = r.span()
                return (StructuredTextImage(s[startt:endt], href=s[starth:endh], 
                        align=s[starta:enda]), start, end)
       

        r = expr3(s)
        if r:
                startt, endt = r.span(1)
                starth, endh = r.span(3)
                starta, enda = r.span(2)
                start, end = r.span()
                return (StructuredTextImage(s[startt:endt], href=s[starth:endh],
                        align=s[starta:enda]), start, end)

        r = expr2(s)
        if r:
                startt, endt = r.span(1)
                starth, endh = r.span(2)
                start, end = r.span()
                return (StructuredTextImage(s[startt:endt], href=s[starth:endh]),
                        start, end)

        r = expr1(s)
        if r:
                startt, endt = r.span(1)
                starth, endh = r.span(2)
                start, end = r.span()
                return (StructuredTextImage(s[startt:endt], href=s[starth:endh]),
                        start, end)

        return None

