##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
#
##############################################################################
#
# Modified by Oliver Keller <oli@deswahnsinnsfettebute.de>
# - dropped the old "Figure" feature
# - implemented image alignment:
#   img-left, -right, -middle, -top, -bottom: these are the usual align= 
#   options for the img tag
# - made bild-links, -rechts, -smitte, -oben, -unten  also work 
#   (german: smitte steht fr "senkrechte mitte" und entsricht img-middle)
#   you can easily change "bild" into any other keyword.
#   see inside the modified DocumentWithImages.py
# - additionally added img-center and bild-mitte. this is a workaround: 
#   this allows you to place images horizontal centered (text->picture->text)
# last changed: 18.03.2003


from HTMLClass import HTMLClass

ets = HTMLClass.element_types
ets.update({'StructuredTextImage': 'image'})

class HTMLWithImages(HTMLClass):

    element_types = ets


    def image(self, doc, level, output):

       # some translation from german into english syntax:
       if hasattr(doc, 'align'):
          if doc.align == "l" :
             doc.align = "left"
          if doc.align == "r" :
             doc.align = "right" 
          if doc.align == "t" :
             doc.align = "top"
          if doc.align == "b" :
             doc.align = "bottom"
          if doc.align == "m" :
             doc.align = "middle"
          if doc.align == "c" :
             doc.align = "center"
	  # align=center is not implemented in HTML4! workaround:
          if doc.align != "center" :
             output('<a href="%s/sys_show_fullimage"><img src="%s.thumb.jpg" alt="%s" align="%s"></a>\n' % (doc.href, doc.href, doc.getNodeValue(), doc.align))
          elif doc.align == "center" :
            output('<p align="center"><a href="%s/sys_show_fullimage"><img src="%s.thumb.jpg" alt="%s" ></a></p>\n' % (doc.href, doc.href, doc.getNodeValue()))
       else:
           output('<img src="%s" alt="%s">\n' % (doc.href, doc.getNodeValue()))